// ONSBJ21.pde
// On Ne Se Baigne Jamais
// Sketch Processing 3
// Gerard Paresys  Guykayser
// 21 1 2019
//
// = ONSBJ20 avec:
//   9 voix (au lieu de 6)
//   Le sketch s'adapte automatiquement au nombre de voix en ajoutant/supprimant des lignes en 35 .. 43
//   LimniMini LimniMaxi calcules dans limniseul2019.pde mais inutile ici
//   LimniMini LimniMaxi en mm comme LimniHauteur[IndiceLimni]
//
// http://gerard.paresys.free.fr/Journal/LimnimetreSuite.html
//
// Processing 3
//   + library minim (Sampler .. AudioOutput)
//   + library java.util.Date   // limniseul2019
//   + library java.text.SimpleDateFormat  // limniseul2019
//

import ddf.minim.*;
import ddf.minim.ugens.*;

boolean Vertical       = false; // true pour écran Raspberry
boolean AfficheMenu    = true;  // true false
boolean AfficheConsole = false;
int FacteurMax         = 6;     // 10 sous MacOS OK  3 sous Raspbian
int maxVoices          = 2;     // 4 the maximum number of voices for Sampler
int SilenceMin         = 5000;  // msec
int SilenceMax         = 30000; // msec
int SilenceAleaMin     = 50;   // 50 msec
int SilenceAleaMax     = 4000;  // 100 msec

String[] NomFichier = {
  "ONSBJ_damien", 
  "ONSBJ_delarue", 
  "ONSBJ_jeanherve", 
  "ONSBJ_alexei", 
  "ONSBJ_anna", 
  "ONSBJ_mmecheval", 
  "ONSBJ_mllecheval", 
  "ONSBJ_mrcheval", 
  "ONSBJ_mrcheval2"
};

int NVoix = NomFichier.length; 
String[] NomFichierAudio = new String[NVoix];
String[] NomFichierXML = new String[NVoix];
int[] Duree = new int[NVoix];
boolean[] VoixOn = new boolean[NVoix];


float NiveauSonore = 1.0 / FacteurMax; // pour ne pas saturer

int NombreCouche = 5; 
int Couche = 3;  // 0 .. 4
int Facteur = FacteurMax;
boolean Alea = false;
int tailleTexte  = 200;

int Voix;  // 0 .. 5
PFont FontExo2;
float hhh;
PImage ImageFond;

Minim MonMinim;
Sampler[] LecteurAudio = new Sampler[NVoix * FacteurMax];
AudioOutput Sortie;

int Temps, TempsPause;
int[] TempsPaus = new int[NVoix]; //ms
int[] TempsVoix = new int[NVoix * FacteurMax]; //ms
int[] IndexXML = new int[NVoix * FacteurMax]; 
boolean Initialisation = true;

void settings() {
  if (Vertical) fullScreen(); 
  else size(600, 1024);
}

void setup() {
  fill(0);
  FontExo2 = loadFont("Exo-Bold-200.vlw");
  textFont(FontExo2);
  // smooth();
  ImageFond = loadImage("limniraspberry.png");

  for (Voix = 0; Voix < NVoix; Voix = Voix+1) {
    NomFichierAudio[Voix] = NomFichier[Voix] + ".wav";
    NomFichierXML[Voix] = NomFichier[Voix] + ".xml";
    VoixOn[Voix] = true;
  }

  setuplimniseul();
  println("NiveauSonore = " + NiveauSonore);
  for (Voix = 0; Voix < NVoix; Voix++) Ouverture(NomFichierXML[Voix], Voix);

  MonMinim = new Minim(this);
  // MonMinim.debugOn();
  Sortie = MonMinim.getLineOut(Minim.MONO, 2048);

  for (Voix = 0; Voix < NVoix; Voix++) {
    if (loadStrings(NomFichierAudio[Voix]) == null) println("9 Le fichier " + NomFichierAudio + " n'existe pas");
    else {
      println("Ouverture de Voix " + Voix + ": " + NomFichierAudio[Voix]);
      for (int Fac = 0; Fac < FacteurMax; Fac++) {
        LecteurAudio[Voix + (NVoix * Fac)] = new Sampler(NomFichierAudio[Voix], maxVoices, MonMinim);
        LecteurAudio[Voix + (NVoix * Fac)].amplitude.setLastValue(NiveauSonore); 
        LecteurAudio[Voix + (NVoix * Fac)].patch(Sortie); // patch the file player to the output
        if (AfficheConsole) println("LecteurAudio[" + (Voix + (NVoix *  Fac)) + "]");
      }
    }
  }

  noStroke();
  // frameRate(30);
  Initialisation = true;
  println("Fin setup()");
}

void draw() {
  //if (Vertical) {
  //  rotate(HALF_PI);
  //  translate(0, -width);
  //}
  if (Vertical) {
    rotate(-HALF_PI);   
    translate(-600, 0);
  }

  if (Initialisation) {
    RAZ();
    TempsPause = millis();
    Initialisation = false;
  } else {
    CalculIndiceLimni();
    for (Voix = 0; Voix < NVoix; Voix++) {
      if (VoixOn[Voix]) {
        if (Alea) {
          for (int Fac = 0; Fac < Facteur; Fac++) {
            Temps = millis() - TempsPause; // ms
            if (Temps > TempsVoix[Voix + (NVoix * Fac)]) {
              IndexXML[Voix + (NVoix * Fac)] = int(random(0, XMLTier[Voix][Couche].length));
              XML kid1 = XMLTier[Voix][Couche][IndexXML[Voix + (NVoix * Fac)]];
              float xmin = 1000 * float(kid1.getChild("FIELD2").getContent()); // ms
              float xmax = 1000 * float(kid1.getChild("FIELD3").getContent()); // ms
              String Content1 = kid1.getChild("FIELD4").getContent();
              if (AfficheConsole) println("Voix+(NVoix*Fac)=" + (Voix + (NVoix * Fac)) + "  " + IndexXML[Voix+(2* Fac)] + "  " + Content1 + "   Temps = " + Temps + "   TempsVoix[Voix+(2* Fac)] = " + TempsVoix[Voix+(2* Fac)] + "   xmin = " + xmin + "   xmax = " + xmax + "   IndexXML[" + (Voix+(2*Fac)) + "] = " + IndexXML[Voix+(2*Fac)]);
              // if (Temps > xmin) {
              // fill(255, 150); // semi-transparent white //(255, 50)
              // rect(0, 0, width, height);
              image(ImageFond, 0, 0);
              textSize(tailleTexte);
              fill(255, 0, 0);
              textAlign(CENTER, CENTER);
              if (Vertical) text(Content1, height/2, width/2 - tailleTexte + 120);
              else text(Content1, width/2, -81 +  height/2);
              if (VoixOn[Voix]) {
                LecteurAudio[Voix + (NVoix * Fac)].begin.setLastValue( 44.1 * xmin ); // samples
                LecteurAudio[Voix + (NVoix * Fac)].end.setLastValue( 44.1 * xmax ); // samples
                LecteurAudio[Voix + (NVoix * Fac)].attack.setLastValue( 0.05 ); // secondes
                LecteurAudio[Voix + (NVoix * Fac)].trigger();
              }
              // int Silence = int(random(SilenceAleaMin, SilenceAleaMax));
              int Silence= int(map(LimniHauteur[IndiceLimni], 0, 3600, SilenceAleaMax, SilenceAleaMin));
              // println("Silence = " + Silence);
              TempsVoix[Voix + (NVoix * Fac)] = Temps + int(xmax-xmin) + Silence + int(random(1, SilenceAleaMin));
            }
          }
          //Facteur = FacteurMax * (LimniHauteur[IndiceLimni] - 800) / 3000;
          //if (Facteur < 1) Facteur = 1;
          //if (Facteur > FacteurMax) Facteur = FacteurMax;
          if (LimniHauteur[IndiceLimni] < PasCrue) { // en mm
            Facteur = 1; // Retour normal quand hauteur <PasCrue = 1600mm
          }
          if (LimniHauteur[IndiceLimni] > Crue2) { // en mm
            Facteur = 2; // EchelleTempsRalenti2 quandhauteur > Crue2 = 1700mm
          }
          if (LimniHauteur[IndiceLimni] > Crue1) { // en mm
            Facteur = 3; // EchelleTempsRalenti1 quandhauteur > Crue1 = 1900mm
          }
          if (LimniHauteur[IndiceLimni] > Crue) { // en mm
            Facteur = FacteurMax; // EchelleTempsRalenti quandhauteur > Crue = 2100mm
          }
          // println("Facteur = " + Facteur);
        } else {
          Temps = millis() - TempsPaus[Voix]; // ms
          if (Temps > TempsVoix[Voix]) {
            if (IndexXML[Voix] < XMLTier[Voix][Couche].length - 1) {
              IndexXML[Voix] = IndexXML[Voix] + 1;
              if (IndexXML[Voix] == 0) LecteurAudio[Voix].trigger();
              XML kid1 = XMLTier[Voix][Couche][IndexXML[Voix]];
              float xmin = 1000 * float(kid1.getChild("FIELD2").getContent()); // ms
              float xmax = 1000 * float(kid1.getChild("FIELD3").getContent()); // ms
              String Content1 = kid1.getChild("FIELD4").getContent();
              if (AfficheConsole) println("Voix " + (Voix) + "  " + IndexXML[Voix] + "  " + Content1 + "   Temps = " + Temps + "   TempsVoix[Voix] = " + TempsVoix[Voix] + "   xmin = " + xmin + "   xmax = " + xmax + "   IndexXML[" + (Voix) + "] = " + IndexXML[Voix]);
              image(ImageFond, 0, 0);
              textSize(tailleTexte);
              fill(255, 0, 0);
              textAlign(CENTER, CENTER);
              if (Vertical) text(Content1, height/2, width/2 - tailleTexte + 120);
              else text(Content1, width/2, - 81 +  height/2);
              // println("Content1 = " + Content1);
              // if ((Voix == 0) && VoixOn[0]) LecteurAudio[Voix].play(int(xmin));
              TempsVoix[Voix] = int(xmax);
              //int Silence = int(random(SilenceMin, SilenceMax));
              //println("Silence = " + Silence);
              //TempsVoix[Voix] = int(xmax) + Silence;
            } else {
              if (VoixOn[Voix]) {
                // println("else " );
                LecteurAudio[Voix].begin.setLastValue(0); // Debut
                LecteurAudio[Voix].end.setLastValue( 44.1 * Duree[Voix] ); // samples fin
                // println("Init Voix " + Voix);
                IndexXML [Voix] = -1;
                // TempsVoix[Voix] = 0;
                int Silence = int(random(SilenceMin, SilenceMax));
                // println("Silence = " + Silence);
                // TempsVoix[Voix] = Silence;
                // TempsPaus[Voix] = millis();
                TempsVoix[Voix] = 0;
                TempsPaus[Voix] = millis() + Silence;
                // LecteurAudio[Voix].trigger();
              }
            }
          }
          if ((frameCount % 60) == 0) image(ImageFond, 0, 0);
        }
      } 
      // if (!VoixOn[0] && !VoixOn[1] && !VoixOn[2] && !VoixOn[3] && !VoixOn[4] && !VoixOn[5]) image(ImageFond, 0, 0);
    }

    drawLimniseul();
    // if ((frameCount % 60) == 0) image(ImageFond, 0, 0);

    //if (Vertical) hhh = int(map(LimniHauteur[IndiceLimni], 0, 3600, width - width/10, width/10));// hhh valeur en pixel de la hauteur de l'ecran
    //else hhh = int(map(LimniHauteur[IndiceLimni], 0, 3600, height - height/10, height/10));// hhh valeur en pixel de la hauteur de l'ecran

    if (Vertical) hhh = int(map(LimniHauteur[IndiceLimni], 0, 3600, width, 0));// hhh valeur en pixel de la hauteur de l'ecran
    else hhh = int(map(LimniHauteur[IndiceLimni], 0, 3600, height, 0));// hhh valeur en pixel de la hauteur de l'ecran
    fill(255, 0, 0);
    rect(0, hhh, width, 50);

    fill(255);
    textSize(67);
    textAlign(CENTER, BASELINE);
    if (Vertical) text(LimniHauteur[IndiceLimni] / 10 + " cm", height/2, hhh+50); // cm d'eau
    else text(LimniHauteur[IndiceLimni] / 10 + " cm", width/2, hhh+50); // cm d'eau
    Menu();
  }
}

void keyPressed() {
  for (int i = 0; i < NVoix; i = i+1) {
    if (key == char(49 + i)) VoixOn[i] = !VoixOn[i]; // 1 2 3 4 5 6
  }
  if (key == 'a' || key == 'A') Alea = !Alea;
  for (int i = 0; i < NombreCouche; i = i+1) {
    if (key == char(98 + i) || key == char(66 + i)) Couche = i; // b c d e f B C D E F
  }
  if (key == 'm' || key == 'M') AfficheMenu = !AfficheMenu;
  if (key == 'j' || key == 'J') TempsReel = TempsReel + 1000000;
  RAZ();
}

void RAZ() {
  // println("RAZ  Alea " + Alea + " VoixOn 1 " + VoixOn[0] + "  2 " + VoixOn[1] + "  3 " + VoixOn[2] + "  4 " + VoixOn[3] + "  5 " + VoixOn[4] + "  6 " + VoixOn[5]);
  print("RAZ  Alea " + Alea + " VoixOn " );
  for (int Voi = 0; Voi < NVoix; Voi = Voi+1) {
    print(Voi + 1 + ":" + VoixOn[Voi], "");
    for (int Fac = 0; Fac < FacteurMax; Fac++) {
      IndexXML [Voi + (NVoix * Fac)] = -1;
      TempsVoix[Voi + (NVoix * Fac)] =  0;
    }
  }
  println();
  // TempsPause = millis();
}

void Menu() {
  if (AfficheMenu) {
    textSize(14);
    textAlign(LEFT, TOP);
    fill(0, 0, 200);
    int x = 450;
    int y = 1;
    for (int i = 0; i < NVoix; i = i+1) text(i + 1 + " " + NomFichier[i], x, y++*16);
    text(" ", x, y++*16);
    text("A Aléatoire", x, y++*16);
    text(" ", x, y++*16);
    for (int i = 0; i < NombreCouche; i = i+1) text(char(66 + i) + " " + TierName[i], x, y++*16);    
    text(" ", x, y++*16);
    text("Echap Stop", x, y++*16);
    text("M Menu", x, y++*16);
    text("J Jump", x, y++*16);
    text(" ", x, y++*16);
    //fill(255);
    //rect(x - 3, y*16 - 4, 100, 15);
    //fill(0, 0, 200);
    //text(float(Temps) / 1000 + " sec", x, y++*16);
    //text(" ", x, y++*16);
    text("Cycle" + Cycle, x, y++*16);
    text(int(TempsAvant/1000) + "sec", x, y++*16);
    text("H=" + LimniHauteur[IndiceLimni] / 10 + "cm", x, y++*16);
    text("EchelleTemps=" + EchelleTemps, x, y++*16);
    text("IndiceLimni=" + IndiceLimni, x, y++*16);
  }
}
